VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsUoHuffman"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'##########################################################'
'#        Created by: Fallout <roman3k@mail.ru>           #'
'#Ported from Injection (http://injection.sourceforge.net)#'
'#                        v.57j                           #'
'#          Uo Huffman Compress/Decompress class          #'
'##########################################################'

'28-09-2003
'First release

Option Explicit

Dim tree(0 To 256 * 2 - 1) As Integer
Dim bit_table(0 To 256, 0 To 1) As Integer
Dim treepos As Integer
Dim Value As Integer, mask As Integer
Dim out_data As Long, bit_num As Integer

Public Sub Decompress(InBuffer() As Byte, OutBuffer() As Byte, ByRef dest_size As Integer, ByVal src_size As Integer)
    Dim dest_index As Integer, src_index As Integer
    ReDim OutBuffer(src_size * 4 - 1)
    src_index = 0: dest_index = 0: bit_num = 8: treepos = 0
    Do
Start_Point:
        If (bit_num = 8) Then
            If (src_size = 0) Then dest_size = dest_index: ReDim Preserve OutBuffer(dest_index - 1): Exit Sub
            src_size = src_size - 1
            Value = InBuffer(src_index)
            src_index = src_index + 1
            bit_num = 0
            mask = &H80
        End If
        treepos = IIf((Value And mask), tree(treepos * 2), tree(treepos * 2 + 1))
        mask = shr(mask, 1)
        bit_num = bit_num + 1
        If (treepos <= 0) Then
            If (treepos = -256) Then bit_num = 8: treepos = 0: GoTo Start_Point
            If (dest_index = dest_size) Then dest_size = dest_index: Exit Sub
            OutBuffer(dest_index) = -treepos
            dest_index = dest_index + 1
            treepos = 0
        End If
    Loop
End Sub

Public Sub Compress(InBuffer() As Byte, OutBuffer() As Byte, ByRef dest_size As Integer, ByVal src_size As Integer)
    Dim tmp As Integer, dest_index As Integer, num_bits As Integer
    Dim src_index As Integer
    ReDim OutBuffer(src_size * 2 - 1)
    src_index = 0
    tmp = src_size
    bit_num = 0: out_data = 0
    dest_index = 0
    Do While (bit_num >= 8)
        If (dest_index = dest_size) Then Exit Sub
        bit_num = bit_num - 8
        OutBuffer(dest_index) = (shr(out_data, bit_num)) And &HFF
        dest_index = dest_index + 1
    Loop
    Do While src_size > 0
        src_size = src_size - 1
        num_bits = bit_table(InBuffer(src_index), 0)
        bit_num = bit_num + num_bits
        out_data = (shl(out_data, num_bits)) Or bit_table(InBuffer(src_index), 1)
        src_index = src_index + 1
        Do While (bit_num >= 8)
            If (dest_index = dest_size) Then Exit Sub
            bit_num = bit_num - 8
            OutBuffer(dest_index) = (shr(out_data, bit_num)) And &HFF
            out_data = out_data And &HFF
            dest_index = dest_index + 1
        Loop
    Loop

    dest_size = dest_index
    dest_index = tmp - dest_size
    flush OutBuffer(), dest_size, dest_index, dest_size
    dest_size = dest_size + dest_index
    ReDim Preserve OutBuffer(dest_size - 1)
End Sub
Private Sub flush(ByRef OutBuffer() As Byte, ByVal dest_index As Integer, ByRef dest_size As Integer, ByVal dest_offset As Integer)
    Dim num_bits As Integer
    dest_index = 0
    num_bits = bit_table(256, 0)
    bit_num = bit_num + num_bits
    out_data = (shl(out_data, num_bits)) Or bit_table(256, 1)
    Do While (bit_num >= 8)
        If (dest_index = dest_size) Then Exit Sub
        bit_num = bit_num - 8
        OutBuffer(dest_offset + dest_index) = (shr(out_data, bit_num)) And &HFF
        dest_index = dest_index + 1
    Loop
    If (bit_num > 0) Then
        out_data = shl(out_data, (8 - bit_num))
        OutBuffer(dest_offset + dest_index) = out_data And &HFF
        dest_index = dest_index + 1
        bit_num = 0
    End If
    dest_size = dest_index
End Sub

Private Sub Class_Initialize()
    build_tree_array
    build_bittable_array
End Sub

Private Sub build_tree_array()
    tree(0) = 1: tree(1) = 2: tree(2) = 3: tree(3) = 4: tree(4) = 5: tree(5) = 0: tree(6) = 6: tree(7) = 7
    tree(8) = 8: tree(9) = 9: tree(10) = 10: tree(11) = 11: tree(12) = 12: tree(13) = 13: tree(14) = -256
    tree(15) = 14: tree(16) = 15: tree(17) = 16: tree(18) = 17: tree(19) = 18: tree(20) = 19: tree(21) = 20
    tree(22) = 21: tree(23) = 22: tree(24) = -1: tree(25) = 23: tree(26) = 24: tree(27) = 25: tree(28) = 26
    tree(29) = 27: tree(30) = 28: tree(31) = 29: tree(32) = 30: tree(33) = 31: tree(34) = 32: tree(35) = 33
    tree(36) = 34: tree(37) = 35: tree(38) = 36: tree(39) = 37: tree(40) = 38: tree(41) = 39: tree(42) = 40
    tree(43) = -64: tree(44) = 41: tree(45) = 42: tree(46) = 43: tree(47) = 44: tree(48) = -6: tree(49) = 45
    tree(50) = 46: tree(51) = 47: tree(52) = 48: tree(53) = 49: tree(54) = 50: tree(55) = 51: tree(56) = -119
    tree(57) = 52: tree(58) = -32: tree(59) = 53: tree(60) = 54: tree(61) = -14: tree(62) = 55: tree(63) = -5
    tree(64) = 56: tree(65) = 57: tree(66) = 58: tree(67) = 59: tree(68) = 60: tree(69) = -2: tree(70) = 61
    tree(71) = 62: tree(72) = 63: tree(73) = 64: tree(74) = 65: tree(75) = 66: tree(76) = 67: tree(77) = 68
    tree(78) = 69: tree(79) = 70: tree(80) = 71: tree(81) = 72: tree(82) = -51: tree(83) = 73: tree(84) = 74
    tree(85) = 75: tree(86) = 76: tree(87) = 77: tree(88) = -101: tree(89) = -111: tree(90) = -4: tree(91) = -97
    tree(92) = 78: tree(93) = 79: tree(94) = -110: tree(95) = 80: tree(96) = 81: tree(97) = -116: tree(98) = 82
    tree(99) = 83: tree(100) = 84: tree(101) = -255: tree(102) = 85: tree(103) = 86: tree(104) = 87: tree(105) = 88
    tree(106) = 89: tree(107) = 90: tree(108) = -15: tree(109) = -10: tree(110) = 91: tree(111) = 92: tree(112) = -21
    tree(113) = 93: tree(114) = -117: tree(115) = 94: tree(116) = 95: tree(117) = 96: tree(118) = 97: tree(119) = 98
    tree(120) = 99: tree(121) = 100: tree(122) = -114: tree(123) = 101: tree(124) = -105: tree(125) = 102: tree(126) = -26
    tree(127) = 103: tree(128) = 104: tree(129) = 105: tree(130) = 106: tree(131) = 107: tree(132) = 108: tree(133) = 109
    tree(134) = 110: tree(135) = 111: tree(136) = 112: tree(137) = -3: tree(138) = 113: tree(139) = -7: tree(140) = 114
    tree(141) = -131: tree(142) = 115: tree(143) = -144: tree(144) = 116: tree(145) = 117: tree(146) = -20: tree(147) = 118
    tree(148) = 119: tree(149) = 120: tree(150) = 121: tree(151) = 122: tree(152) = 123: tree(153) = 124: tree(154) = 125
    tree(155) = 126: tree(156) = 127: tree(157) = 128: tree(158) = 129: tree(159) = -100: tree(160) = 130: tree(161) = -8
    tree(162) = 131: tree(163) = 132: tree(164) = 133: tree(165) = 134: tree(166) = -120: tree(167) = 135: tree(168) = 136
    tree(169) = -31: tree(170) = 137: tree(171) = 138: tree(172) = -109: tree(173) = -234: tree(174) = 139: tree(175) = 140
    tree(176) = 141: tree(177) = 142: tree(178) = 143: tree(179) = 144: tree(180) = -112: tree(181) = 145: tree(182) = -19
    tree(183) = 146: tree(184) = 147: tree(185) = 148: tree(186) = 149: tree(187) = -66: tree(188) = 150: tree(189) = -145
    tree(190) = -13: tree(191) = -65: tree(192) = 151: tree(193) = 152: tree(194) = 153: tree(195) = 154: tree(196) = -30
    tree(197) = 155: tree(198) = 156: tree(199) = 157: tree(200) = -99: tree(201) = 158: tree(202) = 159: tree(203) = 160
    tree(204) = 161: tree(205) = 162: tree(206) = -23: tree(207) = 163: tree(208) = -29: tree(209) = 164: tree(210) = -11
    tree(211) = 165: tree(212) = 166: tree(213) = -115: tree(214) = 167: tree(215) = 168: tree(216) = 169: tree(217) = 170
    tree(218) = -16: tree(219) = 171: tree(220) = -34: tree(221) = 172: tree(222) = 173: tree(223) = -132: tree(224) = 174
    tree(225) = -108: tree(226) = 175: tree(227) = -22: tree(228) = 176: tree(229) = -9: tree(230) = 177: tree(231) = -84
    tree(232) = -17: tree(233) = -37: tree(234) = -28: tree(235) = 178: tree(236) = 179: tree(237) = 180: tree(238) = 181
    tree(239) = 182: tree(240) = 183: tree(241) = 184: tree(242) = 185: tree(243) = 186: tree(244) = 187: tree(245) = -104
    tree(246) = 188: tree(247) = -78: tree(248) = 189: tree(249) = -61: tree(250) = -79: tree(251) = -178: tree(252) = -59
    tree(253) = -134: tree(254) = 190: tree(255) = -25: tree(256) = -83: tree(257) = -18: tree(258) = 191: tree(259) = -57
    tree(260) = -67: tree(261) = 192: tree(262) = -98: tree(263) = 193: tree(264) = -12: tree(265) = -68: tree(266) = 194
    tree(267) = 195: tree(268) = -55: tree(269) = -128: tree(270) = -24: tree(271) = -50: tree(272) = -70: tree(273) = 196
    tree(274) = -94: tree(275) = -33: tree(276) = 197: tree(277) = -129: tree(278) = -74: tree(279) = 198: tree(280) = -82
    tree(281) = 199: tree(282) = -56: tree(283) = -87: tree(284) = -44: tree(285) = 200: tree(286) = -248: tree(287) = 201
    tree(288) = -163: tree(289) = -81: tree(290) = -52: tree(291) = -123: tree(292) = 202: tree(293) = -113: tree(294) = -48
    tree(295) = -41: tree(296) = -122: tree(297) = -40: tree(298) = 203: tree(299) = -90: tree(300) = -54: tree(301) = 204
    tree(302) = -86: tree(303) = -192: tree(304) = 205: tree(305) = 206: tree(306) = 207: tree(307) = -130: tree(308) = -53
    tree(309) = 208: tree(310) = -133: tree(311) = -45: tree(312) = 209: tree(313) = 210: tree(314) = 211: tree(315) = -91
    tree(316) = 212: tree(317) = 213: tree(318) = -106: tree(319) = -88: tree(320) = 214: tree(321) = 215: tree(322) = 216
    tree(323) = 217: tree(324) = 218: tree(325) = -49: tree(326) = 219: tree(327) = 220: tree(328) = 221: tree(329) = 222
    tree(330) = 223: tree(331) = 224: tree(332) = 225: tree(333) = 226: tree(334) = 227: tree(335) = -102: tree(336) = -160
    tree(337) = 228: tree(338) = -46: tree(339) = 229: tree(340) = -127: tree(341) = 230: tree(342) = -103: tree(343) = 231
    tree(344) = 232: tree(345) = 233: tree(346) = -60: tree(347) = 234: tree(348) = 235: tree(349) = -76: tree(350) = 236
    tree(351) = -121: tree(352) = 237: tree(353) = -73: tree(354) = -149: tree(355) = 238: tree(356) = 239: tree(357) = -107
    tree(358) = -35: tree(359) = 240: tree(360) = -71: tree(361) = -27: tree(362) = -69: tree(363) = 241: tree(364) = -89
    tree(365) = -77: tree(366) = -62: tree(367) = -118: tree(368) = -75: tree(369) = -85: tree(370) = -72: tree(371) = -58
    tree(372) = -63: tree(373) = -80: tree(374) = 242: tree(375) = -42: tree(376) = -150: tree(377) = -157: tree(378) = -139
    tree(379) = -236: tree(380) = -126: tree(381) = -243: tree(382) = -142: tree(383) = -214: tree(384) = -138: tree(385) = -206
    tree(386) = -240: tree(387) = -146: tree(388) = -204: tree(389) = -147: tree(390) = -152: tree(391) = -201: tree(392) = -227
    tree(393) = -207: tree(394) = -154: tree(395) = -209: tree(396) = -153: tree(397) = -254: tree(398) = -176: tree(399) = -156
    tree(400) = -165: tree(401) = -210: tree(402) = -172: tree(403) = -185: tree(404) = -195: tree(405) = -170: tree(406) = -232
    tree(407) = -211: tree(408) = -219: tree(409) = -239: tree(410) = -200: tree(411) = -177: tree(412) = -175: tree(413) = -212
    tree(414) = -244: tree(415) = -143: tree(416) = -246: tree(417) = -171: tree(418) = -203: tree(419) = -221: tree(420) = -202
    tree(421) = -181: tree(422) = -173: tree(423) = -250: tree(424) = -184: tree(425) = -164: tree(426) = -193: tree(427) = -218
    tree(428) = -199: tree(429) = -220: tree(430) = -190: tree(431) = -249: tree(432) = -230: tree(433) = -217: tree(434) = -169
    tree(435) = -216: tree(436) = -191: tree(437) = -197: tree(438) = -47: tree(439) = 243: tree(440) = 244: tree(441) = 245
    tree(442) = 246: tree(443) = 247: tree(444) = -148: tree(445) = -159: tree(446) = 248: tree(447) = 249: tree(448) = -92
    tree(449) = -93: tree(450) = -96: tree(451) = -225: tree(452) = -151: tree(453) = -95: tree(454) = 250: tree(455) = 251
    tree(456) = -241: tree(457) = 252: tree(458) = -161: tree(459) = -36: tree(460) = 253: tree(461) = 254: tree(462) = -135
    tree(463) = -39: tree(464) = -187: tree(465) = -124: tree(466) = 255: tree(467) = -251: tree(468) = -162: tree(469) = -238
    tree(470) = -242: tree(471) = -38: tree(472) = -43: tree(473) = -125: tree(474) = -215: tree(475) = -253: tree(476) = -140
    tree(477) = -208: tree(478) = -137: tree(479) = -235: tree(480) = -158: tree(481) = -237: tree(482) = -136: tree(483) = -205
    tree(484) = -155: tree(485) = -141: tree(486) = -228: tree(487) = -229: tree(488) = -213: tree(489) = -168: tree(490) = -224
    tree(491) = -194: tree(492) = -196: tree(493) = -226: tree(494) = -183: tree(495) = -233: tree(496) = -231: tree(497) = -167
    tree(498) = -174: tree(499) = -189: tree(500) = -252: tree(501) = -166: tree(502) = -198: tree(503) = -222: tree(504) = -188
    tree(505) = -179: tree(506) = -223: tree(507) = -182: tree(508) = -180: tree(509) = -186: tree(510) = -245: tree(511) = -247
End Sub

Private Sub build_bittable_array()
    bit_table(0, 0) = &H2: bit_table(0, 1) = &H0: bit_table(1, 0) = &H5: bit_table(1, 1) = &H1F
    bit_table(2, 0) = &H6: bit_table(2, 1) = &H22: bit_table(3, 0) = &H7: bit_table(3, 1) = &H34
    bit_table(4, 0) = &H7: bit_table(4, 1) = &H75: bit_table(5, 0) = &H6: bit_table(5, 1) = &H28
    bit_table(6, 0) = &H6: bit_table(6, 1) = &H3B: bit_table(7, 0) = &H7: bit_table(7, 1) = &H32
    bit_table(8, 0) = &H8: bit_table(8, 1) = &HE0: bit_table(9, 0) = &H8: bit_table(9, 1) = &H62
    bit_table(10, 0) = &H7: bit_table(10, 1) = &H56: bit_table(11, 0) = &H8: bit_table(11, 1) = &H79
    bit_table(12, 0) = &H9: bit_table(12, 1) = &H19D: bit_table(13, 0) = &H8: bit_table(13, 1) = &H97
    bit_table(14, 0) = &H6: bit_table(14, 1) = &H2A: bit_table(15, 0) = &H7: bit_table(15, 1) = &H57
    bit_table(16, 0) = &H8: bit_table(16, 1) = &H71: bit_table(17, 0) = &H8: bit_table(17, 1) = &H5B
    bit_table(18, 0) = &H9: bit_table(18, 1) = &H1CC: bit_table(19, 0) = &H8: bit_table(19, 1) = &HA7
    bit_table(20, 0) = &H7: bit_table(20, 1) = &H25: bit_table(21, 0) = &H7: bit_table(21, 1) = &H4F
    bit_table(22, 0) = &H8: bit_table(22, 1) = &H66: bit_table(23, 0) = &H8: bit_table(23, 1) = &H7D
    bit_table(24, 0) = &H9: bit_table(24, 1) = &H191: bit_table(25, 0) = &H9: bit_table(25, 1) = &H1CE
    bit_table(26, 0) = &H7: bit_table(26, 1) = &H3F: bit_table(27, 0) = &H9: bit_table(27, 1) = &H90
    bit_table(28, 0) = &H8: bit_table(28, 1) = &H59: bit_table(29, 0) = &H8: bit_table(29, 1) = &H7B
    bit_table(30, 0) = &H8: bit_table(30, 1) = &H91: bit_table(31, 0) = &H8: bit_table(31, 1) = &HC6
    bit_table(32, 0) = &H6: bit_table(32, 1) = &H2D: bit_table(33, 0) = &H9: bit_table(33, 1) = &H186
    bit_table(34, 0) = &H8: bit_table(34, 1) = &H6F: bit_table(35, 0) = &H9: bit_table(35, 1) = &H93
    bit_table(36, 0) = &HA: bit_table(36, 1) = &H1CC: bit_table(37, 0) = &H8: bit_table(37, 1) = &H5A
    bit_table(38, 0) = &HA: bit_table(38, 1) = &H1AE: bit_table(39, 0) = &HA: bit_table(39, 1) = &H1C0
    bit_table(40, 0) = &H9: bit_table(40, 1) = &H148: bit_table(41, 0) = &H9: bit_table(41, 1) = &H14A
    bit_table(42, 0) = &H9: bit_table(42, 1) = &H82: bit_table(43, 0) = &HA: bit_table(43, 1) = &H19F
    bit_table(44, 0) = &H9: bit_table(44, 1) = &H171: bit_table(45, 0) = &H9: bit_table(45, 1) = &H120
    bit_table(46, 0) = &H9: bit_table(46, 1) = &HE7: bit_table(47, 0) = &HA: bit_table(47, 1) = &H1F3
    bit_table(48, 0) = &H9: bit_table(48, 1) = &H14B: bit_table(49, 0) = &H9: bit_table(49, 1) = &H100
    bit_table(50, 0) = &H9: bit_table(50, 1) = &H190: bit_table(51, 0) = &H6: bit_table(51, 1) = &H13
    bit_table(52, 0) = &H9: bit_table(52, 1) = &H161: bit_table(53, 0) = &H9: bit_table(53, 1) = &H125
    bit_table(54, 0) = &H9: bit_table(54, 1) = &H133: bit_table(55, 0) = &H9: bit_table(55, 1) = &H195
    bit_table(56, 0) = &H9: bit_table(56, 1) = &H173: bit_table(57, 0) = &H9: bit_table(57, 1) = &H1CA
    bit_table(58, 0) = &H9: bit_table(58, 1) = &H86: bit_table(59, 0) = &H9: bit_table(59, 1) = &H1E9
    bit_table(60, 0) = &H9: bit_table(60, 1) = &HDB: bit_table(61, 0) = &H9: bit_table(61, 1) = &H1EC
    bit_table(62, 0) = &H9: bit_table(62, 1) = &H8B: bit_table(63, 0) = &H9: bit_table(63, 1) = &H85
    bit_table(64, 0) = &H5: bit_table(64, 1) = &HA: bit_table(65, 0) = &H8: bit_table(65, 1) = &H96
    bit_table(66, 0) = &H8: bit_table(66, 1) = &H9C: bit_table(67, 0) = &H9: bit_table(67, 1) = &H1C3
    bit_table(68, 0) = &H9: bit_table(68, 1) = &H19C: bit_table(69, 0) = &H9: bit_table(69, 1) = &H8F
    bit_table(70, 0) = &H9: bit_table(70, 1) = &H18F: bit_table(71, 0) = &H9: bit_table(71, 1) = &H91
    bit_table(72, 0) = &H9: bit_table(72, 1) = &H87: bit_table(73, 0) = &H9: bit_table(73, 1) = &HC6
    bit_table(74, 0) = &H9: bit_table(74, 1) = &H177: bit_table(75, 0) = &H9: bit_table(75, 1) = &H89
    bit_table(76, 0) = &H9: bit_table(76, 1) = &HD6: bit_table(77, 0) = &H9: bit_table(77, 1) = &H8C
    bit_table(78, 0) = &H9: bit_table(78, 1) = &H1EE: bit_table(79, 0) = &H9: bit_table(79, 1) = &H1EB
    bit_table(80, 0) = &H9: bit_table(80, 1) = &H84: bit_table(81, 0) = &H9: bit_table(81, 1) = &H164
    bit_table(82, 0) = &H9: bit_table(82, 1) = &H175: bit_table(83, 0) = &H9: bit_table(83, 1) = &H1CD
    bit_table(84, 0) = &H8: bit_table(84, 1) = &H5E: bit_table(85, 0) = &H9: bit_table(85, 1) = &H88
    bit_table(86, 0) = &H9: bit_table(86, 1) = &H12B: bit_table(87, 0) = &H9: bit_table(87, 1) = &H172
    bit_table(88, 0) = &H9: bit_table(88, 1) = &H10A: bit_table(89, 0) = &H9: bit_table(89, 1) = &H8D
    bit_table(90, 0) = &H9: bit_table(90, 1) = &H13A: bit_table(91, 0) = &H9: bit_table(91, 1) = &H11C
    bit_table(92, 0) = &HA: bit_table(92, 1) = &H1E1: bit_table(93, 0) = &HA: bit_table(93, 1) = &H1E0
    bit_table(94, 0) = &H9: bit_table(94, 1) = &H187: bit_table(95, 0) = &HA: bit_table(95, 1) = &H1DC
    bit_table(96, 0) = &HA: bit_table(96, 1) = &H1DF: bit_table(97, 0) = &H7: bit_table(97, 1) = &H74
    bit_table(98, 0) = &H9: bit_table(98, 1) = &H19F: bit_table(99, 0) = &H8: bit_table(99, 1) = &H8D
    bit_table(100, 0) = &H8: bit_table(100, 1) = &HE4: bit_table(101, 0) = &H7: bit_table(101, 1) = &H79
    bit_table(102, 0) = &H9: bit_table(102, 1) = &HEA: bit_table(103, 0) = &H9: bit_table(103, 1) = &HE1
    bit_table(104, 0) = &H8: bit_table(104, 1) = &H40: bit_table(105, 0) = &H7: bit_table(105, 1) = &H41
    bit_table(106, 0) = &H9: bit_table(106, 1) = &H10B: bit_table(107, 0) = &H9: bit_table(107, 1) = &HB0
    bit_table(108, 0) = &H8: bit_table(108, 1) = &H6A: bit_table(109, 0) = &H8: bit_table(109, 1) = &HC1
    bit_table(110, 0) = &H7: bit_table(110, 1) = &H71: bit_table(111, 0) = &H7: bit_table(111, 1) = &H78
    bit_table(112, 0) = &H8: bit_table(112, 1) = &HB1: bit_table(113, 0) = &H9: bit_table(113, 1) = &H14C
    bit_table(114, 0) = &H7: bit_table(114, 1) = &H43: bit_table(115, 0) = &H8: bit_table(115, 1) = &H76
    bit_table(116, 0) = &H7: bit_table(116, 1) = &H66: bit_table(117, 0) = &H7: bit_table(117, 1) = &H4D
    bit_table(118, 0) = &H9: bit_table(118, 1) = &H8A: bit_table(119, 0) = &H6: bit_table(119, 1) = &H2F
    bit_table(120, 0) = &H8: bit_table(120, 1) = &HC9: bit_table(121, 0) = &H9: bit_table(121, 1) = &HCE
    bit_table(122, 0) = &H9: bit_table(122, 1) = &H149: bit_table(123, 0) = &H9: bit_table(123, 1) = &H160
    bit_table(124, 0) = &HA: bit_table(124, 1) = &H1BA: bit_table(125, 0) = &HA: bit_table(125, 1) = &H19E
    bit_table(126, 0) = &HA: bit_table(126, 1) = &H39F: bit_table(127, 0) = &H9: bit_table(127, 1) = &HE5
    bit_table(128, 0) = &H9: bit_table(128, 1) = &H194: bit_table(129, 0) = &H9: bit_table(129, 1) = &H184
    bit_table(130, 0) = &H9: bit_table(130, 1) = &H126: bit_table(131, 0) = &H7: bit_table(131, 1) = &H30
    bit_table(132, 0) = &H8: bit_table(132, 1) = &H6C: bit_table(133, 0) = &H9: bit_table(133, 1) = &H121
    bit_table(134, 0) = &H9: bit_table(134, 1) = &H1E8: bit_table(135, 0) = &HA: bit_table(135, 1) = &H1C1
    bit_table(136, 0) = &HA: bit_table(136, 1) = &H11D: bit_table(137, 0) = &HA: bit_table(137, 1) = &H163
    bit_table(138, 0) = &HA: bit_table(138, 1) = &H385: bit_table(139, 0) = &HA: bit_table(139, 1) = &H3DB
    bit_table(140, 0) = &HA: bit_table(140, 1) = &H17D: bit_table(141, 0) = &HA: bit_table(141, 1) = &H106
    bit_table(142, 0) = &HA: bit_table(142, 1) = &H397: bit_table(143, 0) = &HA: bit_table(143, 1) = &H24E
    bit_table(144, 0) = &H7: bit_table(144, 1) = &H2E: bit_table(145, 0) = &H8: bit_table(145, 1) = &H98
    bit_table(146, 0) = &HA: bit_table(146, 1) = &H33C: bit_table(147, 0) = &HA: bit_table(147, 1) = &H32E
    bit_table(148, 0) = &HA: bit_table(148, 1) = &H1E9: bit_table(149, 0) = &H9: bit_table(149, 1) = &HBF
    bit_table(150, 0) = &HA: bit_table(150, 1) = &H3DF: bit_table(151, 0) = &HA: bit_table(151, 1) = &H1DD
    bit_table(152, 0) = &HA: bit_table(152, 1) = &H32D: bit_table(153, 0) = &HA: bit_table(153, 1) = &H2ED
    bit_table(154, 0) = &HA: bit_table(154, 1) = &H30B: bit_table(155, 0) = &HA: bit_table(155, 1) = &H107
    bit_table(156, 0) = &HA: bit_table(156, 1) = &H2E8: bit_table(157, 0) = &HA: bit_table(157, 1) = &H3DE
    bit_table(158, 0) = &HA: bit_table(158, 1) = &H125: bit_table(159, 0) = &HA: bit_table(159, 1) = &H1E8
    bit_table(160, 0) = &H9: bit_table(160, 1) = &HE9: bit_table(161, 0) = &HA: bit_table(161, 1) = &H1CD
    bit_table(162, 0) = &HA: bit_table(162, 1) = &H1B5: bit_table(163, 0) = &H9: bit_table(163, 1) = &H165
    bit_table(164, 0) = &HA: bit_table(164, 1) = &H232: bit_table(165, 0) = &HA: bit_table(165, 1) = &H2E1
    bit_table(166, 0) = &HB: bit_table(166, 1) = &H3AE: bit_table(167, 0) = &HB: bit_table(167, 1) = &H3C6
    bit_table(168, 0) = &HB: bit_table(168, 1) = &H3E2: bit_table(169, 0) = &HA: bit_table(169, 1) = &H205
    bit_table(170, 0) = &HA: bit_table(170, 1) = &H29A: bit_table(171, 0) = &HA: bit_table(171, 1) = &H248
    bit_table(172, 0) = &HA: bit_table(172, 1) = &H2CD: bit_table(173, 0) = &HA: bit_table(173, 1) = &H23B
    bit_table(174, 0) = &HB: bit_table(174, 1) = &H3C5: bit_table(175, 0) = &HA: bit_table(175, 1) = &H251
    bit_table(176, 0) = &HA: bit_table(176, 1) = &H2E9: bit_table(177, 0) = &HA: bit_table(177, 1) = &H252
    bit_table(178, 0) = &H9: bit_table(178, 1) = &H1EA: bit_table(179, 0) = &HB: bit_table(179, 1) = &H3A0
    bit_table(180, 0) = &HB: bit_table(180, 1) = &H391: bit_table(181, 0) = &HA: bit_table(181, 1) = &H23C
    bit_table(182, 0) = &HB: bit_table(182, 1) = &H392: bit_table(183, 0) = &HB: bit_table(183, 1) = &H3D5
    bit_table(184, 0) = &HA: bit_table(184, 1) = &H233: bit_table(185, 0) = &HA: bit_table(185, 1) = &H2CC
    bit_table(186, 0) = &HB: bit_table(186, 1) = &H390: bit_table(187, 0) = &HA: bit_table(187, 1) = &H1BB
    bit_table(188, 0) = &HB: bit_table(188, 1) = &H3A1: bit_table(189, 0) = &HB: bit_table(189, 1) = &H3C4
    bit_table(190, 0) = &HA: bit_table(190, 1) = &H211: bit_table(191, 0) = &HA: bit_table(191, 1) = &H203
    bit_table(192, 0) = &H9: bit_table(192, 1) = &H12A: bit_table(193, 0) = &HA: bit_table(193, 1) = &H231
    bit_table(194, 0) = &HB: bit_table(194, 1) = &H3E0: bit_table(195, 0) = &HA: bit_table(195, 1) = &H29B
    bit_table(196, 0) = &HB: bit_table(196, 1) = &H3D7: bit_table(197, 0) = &HA: bit_table(197, 1) = &H202
    bit_table(198, 0) = &HB: bit_table(198, 1) = &H3AD: bit_table(199, 0) = &HA: bit_table(199, 1) = &H213
    bit_table(200, 0) = &HA: bit_table(200, 1) = &H253: bit_table(201, 0) = &HA: bit_table(201, 1) = &H32C
    bit_table(202, 0) = &HA: bit_table(202, 1) = &H23D: bit_table(203, 0) = &HA: bit_table(203, 1) = &H23F
    bit_table(204, 0) = &HA: bit_table(204, 1) = &H32F: bit_table(205, 0) = &HA: bit_table(205, 1) = &H11C
    bit_table(206, 0) = &HA: bit_table(206, 1) = &H384: bit_table(207, 0) = &HA: bit_table(207, 1) = &H31C
    bit_table(208, 0) = &HA: bit_table(208, 1) = &H17C: bit_table(209, 0) = &HA: bit_table(209, 1) = &H30A
    bit_table(210, 0) = &HA: bit_table(210, 1) = &H2E0: bit_table(211, 0) = &HA: bit_table(211, 1) = &H276
    bit_table(212, 0) = &HA: bit_table(212, 1) = &H250: bit_table(213, 0) = &HB: bit_table(213, 1) = &H3E3
    bit_table(214, 0) = &HA: bit_table(214, 1) = &H396: bit_table(215, 0) = &HA: bit_table(215, 1) = &H18F
    bit_table(216, 0) = &HA: bit_table(216, 1) = &H204: bit_table(217, 0) = &HA: bit_table(217, 1) = &H206
    bit_table(218, 0) = &HA: bit_table(218, 1) = &H230: bit_table(219, 0) = &HA: bit_table(219, 1) = &H265
    bit_table(220, 0) = &HA: bit_table(220, 1) = &H212: bit_table(221, 0) = &HA: bit_table(221, 1) = &H23E
    bit_table(222, 0) = &HB: bit_table(222, 1) = &H3AC: bit_table(223, 0) = &HB: bit_table(223, 1) = &H393
    bit_table(224, 0) = &HB: bit_table(224, 1) = &H3E1: bit_table(225, 0) = &HA: bit_table(225, 1) = &H1DE
    bit_table(226, 0) = &HB: bit_table(226, 1) = &H3D6: bit_table(227, 0) = &HA: bit_table(227, 1) = &H31D
    bit_table(228, 0) = &HB: bit_table(228, 1) = &H3E5: bit_table(229, 0) = &HB: bit_table(229, 1) = &H3E4
    bit_table(230, 0) = &HA: bit_table(230, 1) = &H207: bit_table(231, 0) = &HB: bit_table(231, 1) = &H3C7
    bit_table(232, 0) = &HA: bit_table(232, 1) = &H277: bit_table(233, 0) = &HB: bit_table(233, 1) = &H3D4
    bit_table(234, 0) = &H8: bit_table(234, 1) = &HC0: bit_table(235, 0) = &HA: bit_table(235, 1) = &H162
    bit_table(236, 0) = &HA: bit_table(236, 1) = &H3DA: bit_table(237, 0) = &HA: bit_table(237, 1) = &H124
    bit_table(238, 0) = &HA: bit_table(238, 1) = &H1B4: bit_table(239, 0) = &HA: bit_table(239, 1) = &H264
    bit_table(240, 0) = &HA: bit_table(240, 1) = &H33D: bit_table(241, 0) = &HA: bit_table(241, 1) = &H1D1
    bit_table(242, 0) = &HA: bit_table(242, 1) = &H1AF: bit_table(243, 0) = &HA: bit_table(243, 1) = &H39E
    bit_table(244, 0) = &HA: bit_table(244, 1) = &H24F: bit_table(245, 0) = &HB: bit_table(245, 1) = &H373
    bit_table(246, 0) = &HA: bit_table(246, 1) = &H249: bit_table(247, 0) = &HB: bit_table(247, 1) = &H372
    bit_table(248, 0) = &H9: bit_table(248, 1) = &H167: bit_table(249, 0) = &HA: bit_table(249, 1) = &H210
    bit_table(250, 0) = &HA: bit_table(250, 1) = &H23A: bit_table(251, 0) = &HA: bit_table(251, 1) = &H1B8
    bit_table(252, 0) = &HB: bit_table(252, 1) = &H3AF: bit_table(253, 0) = &HA: bit_table(253, 1) = &H18E
    bit_table(254, 0) = &HA: bit_table(254, 1) = &H2EC: bit_table(255, 0) = &H7: bit_table(255, 1) = &H62
    bit_table(256, 0) = &H4: bit_table(256, 1) = &HD
End Sub

'Private Function shl(ByVal Value As Long, ByVal shift As Integer) As Long
'    shl = Value * (2 ^ shift) 'slow method
'End Function

'Private Function shr(ByVal Value As Long, ByVal shift As Integer) As Long
'    shr = Value \ (2 ^ shift) 'slow method
'End Function
